class gauges_goose_3 extends TemplateElement {
    constructor() {
        super();
        this.location = "interior";
        this.curTime = 0.0;
        this.bNeedUpdate = false;
        this._isConnected = false;
    }
    get templateID() { return "gauges_goose_3"; }
    connectedCallback() {
        super.connectedCallback();
        let parsedUrl = new URL(this.getAttribute("Url").toLowerCase());
        let updateLoop = () => {
            if (!this._isConnected)
                return;
            this.Update();
            requestAnimationFrame(updateLoop);
        };
        this._isConnected = true;
        requestAnimationFrame(updateLoop);
    }
    disconnectedCallback() {
    }
    Update() {
		this.updateInstruments();
    }
    /*playInstrumentSound(soundId) {
        if (this.isElectricityAvailable()) {
            Coherent.call("PLAY_INSTRUMENT_SOUND", soundId);
            return true;
        }
        return false;
    }	*/
    updateInstruments() {

       // TAXI LIGHTS CONTROL
       if (SimVar.GetSimVarValue("IS GEAR RETRACTABLE", "Boolean")) {
         var gears_extracted = SimVar.GetSimVarValue("GEAR HANDLE POSITION", "Boolean");
         if (SimVar.GetSimVarValue("LIGHT TAXI", "bool") && !gears_extracted)
            SimVar.SetSimVarValue("K:TOGGLE_TAXI_LIGHTS", "bool", false)
         else if (!SimVar.GetSimVarValue("LIGHT TAXI", "bool") && gears_extracted)
            SimVar.SetSimVarValue("K:TOGGLE_TAXI_LIGHTS", "bool", true)
       }


		/* RPM_RPM_NEEDLE_LEFT_0 */
		var RPM_rpm_needle_left_0 = this.querySelector("#RPM_rpm_needle_left_0");
		if (typeof RPM_rpm_needle_left_0 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = SimVar.GetSimVarValue("GENERAL ENG RPM:2", "Rpm"); /* PARSED FROM "(A:GENERAL ENG1 RPM, rpm)" */
			var Minimum = 0.000;
			ExpressionResult = Math.max(ExpressionResult, Minimum);
			var Maximum = 4500.000;
			ExpressionResult = Math.min(ExpressionResult, Maximum);
			var PointsTo = 0; 
			var NonlinearityTable = [
				[0, 558.331326253781],
				[2000, 703.076630523424],
				[4000, 847.851761316251],
			];

			if (NonlinearityTable.length > 0) {
			    Minimum = NonlinearityTable[0][0];
			    ExpressionResult = Math.max(ExpressionResult, Minimum);
			    Maximum = NonlinearityTable[NonlinearityTable.length-1][0];
			    ExpressionResult = Math.min(ExpressionResult, Maximum);
				var prevAngle = 0;
				var result = 0;
				var prevVal = Minimum;
				for (var i = 0; i < NonlinearityTable.length; i++) {
					var NonlinearityEntry = NonlinearityTable[i][0];
					var NonlinearityAngle = NonlinearityTable[i][1];
					if (NonlinearityAngle < 0) { NonlinearityAngle += 360 };
					if (ExpressionResult == NonlinearityEntry || prevAngle == NonlinearityAngle && ExpressionResult > prevVal && ExpressionResult < NonlinearityEntry) {
						result = NonlinearityAngle;
						break;
					}
					else if (ExpressionResult > prevVal && ExpressionResult < NonlinearityEntry ) {
						var coef = 1 - (NonlinearityEntry - ExpressionResult) / (NonlinearityEntry - prevVal);

						result = prevAngle + coef * (NonlinearityAngle - prevAngle);
						break;
					}
					prevVal = NonlinearityEntry;
					prevAngle = NonlinearityAngle;
				}

				if (Minimum >= 0)
					while (result < 0)
						result += 360;

				transform += 'rotate(' + (result + PointsTo) + 'deg) ';
			}

		  }
		  if (transform != '')
		    RPM_rpm_needle_left_0.style.transform = transform; 

		}

		/* RPM_RPM_NEEDLE_RIGHT_1 */
		var RPM_rpm_needle_right_1 = this.querySelector("#RPM_rpm_needle_right_1");
		if (typeof RPM_rpm_needle_right_1 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = SimVar.GetSimVarValue("GENERAL ENG RPM:1", "Rpm"); /* PARSED FROM "(A:GENERAL ENG2 RPM, rpm)" */
			var Minimum = 0.000;
			ExpressionResult = Math.max(ExpressionResult, Minimum);
			var Maximum = 4500.000;
			ExpressionResult = Math.min(ExpressionResult, Maximum);
			var PointsTo = 90; 
			var NonlinearityTable = [
				[0, 557.9892787241],
				[2000, 703.24478965296],
				[4000, 847.899092174407],
			];

			if (NonlinearityTable.length > 0) {
			    Minimum = NonlinearityTable[0][0];
			    ExpressionResult = Math.max(ExpressionResult, Minimum);
			    Maximum = NonlinearityTable[NonlinearityTable.length-1][0];
			    ExpressionResult = Math.min(ExpressionResult, Maximum);
				var prevAngle = 0;
				var result = 0;
				var prevVal = Minimum;
				for (var i = 0; i < NonlinearityTable.length; i++) {
					var NonlinearityEntry = NonlinearityTable[i][0];
					var NonlinearityAngle = NonlinearityTable[i][1];
					if (NonlinearityAngle < 0) { NonlinearityAngle += 360 };
					if (ExpressionResult == NonlinearityEntry || prevAngle == NonlinearityAngle && ExpressionResult > prevVal && ExpressionResult < NonlinearityEntry) {
						result = NonlinearityAngle;
						break;
					}
					else if (ExpressionResult > prevVal && ExpressionResult < NonlinearityEntry ) {
						var coef = 1 - (NonlinearityEntry - ExpressionResult) / (NonlinearityEntry - prevVal);

						result = prevAngle + coef * (NonlinearityAngle - prevAngle);
						break;
					}
					prevVal = NonlinearityEntry;
					prevAngle = NonlinearityAngle;
				}

				if (Minimum >= 0)
					while (result < 0)
						result += 360;

				transform += 'rotate(' + (result + PointsTo) + 'deg) ';
			}

		  }
		  if (transform != '')
		    RPM_rpm_needle_right_1.style.transform = transform; 

		}

		/* ALTIMETER_ALTIMETER_KOHLSMAN_STRIP_0 */
		var altimeter_altimeter_kohlsman_strip_0 = this.querySelector("#altimeter_altimeter_kohlsman_strip_0");
		if (typeof altimeter_altimeter_kohlsman_strip_0 !== "undefined") {
		  var transform = '';

		  {
			var ExpressionResult = SimVar.GetSimVarValue("KOHLSMAN SETTING HG", "inches of mercury") - 27.9; /* PARSED FROM "(A:Kohlsman setting hg,inHg) 27.9 -" */
			var Minimum = 0.000;
			ExpressionResult = Math.max(ExpressionResult, Minimum);
			var Maximum = 4.100;
			ExpressionResult = Math.min(ExpressionResult, Maximum);
			transform += 'translate(' + (ExpressionResult * 0) + 'px, ' + (ExpressionResult * -62.45) + 'px) ';
		  }
		  if (transform != '')
		    altimeter_altimeter_kohlsman_strip_0.style.transform = transform; 

		}

		/* ALTIMETER_TEN_THOUSANDS_NEEDLE_1 */
		var altimeter_ten_thousands_needle_1 = this.querySelector("#altimeter_ten_thousands_needle_1");
		if (typeof altimeter_ten_thousands_needle_1 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = (( ( 1 == 2 ) ?  SimVar.GetSimVarValue("INDICATED ALTITUDE", "meters") :  SimVar.GetSimVarValue("INDICATED ALTITUDE", "feet") ) / 100000 * 360)* Math.PI/180; /* PARSED FROM "(P:Units of measure, enum) 2 == if{ (A:Indicated Altitude, meters) } els{ (A:Indicated Altitude, feet) } 100000 / 360 * dgrd" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    altimeter_ten_thousands_needle_1.style.transform = transform; 

		}

		/* ALTIMETER_THOUSANDS_NEEDLE_2 */
		var altimeter_thousands_needle_2 = this.querySelector("#altimeter_thousands_needle_2");
		if (typeof altimeter_thousands_needle_2 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = (( ( 1 == 2 ) ?  SimVar.GetSimVarValue("INDICATED ALTITUDE", "meters") :  SimVar.GetSimVarValue("INDICATED ALTITUDE", "feet") ) / 10000 * 360)* Math.PI/180; /* PARSED FROM "(P:Units of measure, enum) 2 == if{ (A:Indicated Altitude, meters) } els{ (A:Indicated Altitude, feet) } 10000 / 360 * dgrd" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    altimeter_thousands_needle_2.style.transform = transform; 

		}

		/* ALTIMETER_HUNDREDS_NEEDLE_3 */
		var altimeter_hundreds_needle_3 = this.querySelector("#altimeter_hundreds_needle_3");
		if (typeof altimeter_hundreds_needle_3 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = (( ( 1 == 2 ) ?  SimVar.GetSimVarValue("INDICATED ALTITUDE", "meters") :  SimVar.GetSimVarValue("INDICATED ALTITUDE", "feet") ) / 1000 * 360 + 90)* Math.PI/180; /* PARSED FROM "(P:Units of measure, enum) 2 == if{ (A:Indicated Altitude, meters) } els{ (A:Indicated Altitude, feet) } 1000 / 360 * 90 + dgrd" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    altimeter_hundreds_needle_3.style.transform = transform; 

		}

		/* ALTIMETER_KNOB_4 */
		var altimeter_knob_4 = this.querySelector("#altimeter_knob_4");
		if (typeof altimeter_knob_4 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = (0)* Math.PI/180; /* PARSED FROM "(G:Var1) dgrd" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    altimeter_knob_4.style.transform = transform; 

		}

    }
}
registerLivery("gauges_goose_3-element", gauges_goose_3);
